using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;
using System.Xml;

namespace TypingManiaUtility
{
    public partial class Form1 : Form
    {
        Form frm2 = new Form2();

        public Form1()
        {
            InitializeComponent();
        }

        private void panel1_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
                e.Effect = DragDropEffects.Copy;
            else
                e.Effect = DragDropEffects.None;
        }

        private void panel1_DragDrop(object sender, DragEventArgs e)
        {
            string[] fileName = (string[])e.Data.GetData(DataFormats.FileDrop, false);
            axWindowsMediaPlayer1.URL = fileName[0];
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Stream st;
            MemoryStream ms = new MemoryStream();
            if (radioButton2.Checked)
            {
                OpenFileDialog ofd = new OpenFileDialog();
                string flt = "ׂẴt@C(*.*)|*.*";
                if (radioButton3.Checked)
                    flt = "eLXgt@C(*.txt)|*.txt|" + flt;
                else if (radioButton4.Checked)
                    flt = "g^C^Ot̎t@C(*.lrc)|*.lrc|eLXgt@C(*.txt)|*.txt|" + flt;
                else if (radioButton5.Checked)
                    flt = "XMLt@C(*.xml)|*.xml|" + flt;
                ofd.Filter = flt;
                if (ofd.ShowDialog() != DialogResult.OK) return;
                st = ofd.OpenFile();
            }
            else
            {
                if (Clipboard.ContainsText())
                {
                    StreamWriter sw = new StreamWriter(ms);
                    sw.Write(Clipboard.GetText());
                    sw.Flush();
                    st = sw.BaseStream;
                    st.Seek(0, SeekOrigin.Begin);
                }
                else
                {
                    return;
                }
            }
            if (radioButton3.Checked)
            {
                Sample.TxtEnc te = new Sample.TxtEnc();
                StreamReader sr = new StreamReader(st, te.SetFromStream(st));
                sr.BaseStream.Seek(0, SeekOrigin.Begin);
                while (!sr.EndOfStream)
                {
                    string s = sr.ReadLine();
                    dataGridView1.Rows.Add(null, s, KanaConversion.GetReverseConversion(s, textBox1.Handle)[0]);
                }
            }
            else if (radioButton4.Checked)
            {
                Sample.TxtEnc te = new Sample.TxtEnc();
                StreamReader sr = new StreamReader(st, te.SetFromStream(st));
                sr.BaseStream.Seek(0, SeekOrigin.Begin);
                while (!sr.EndOfStream)
                {
                    string s = sr.ReadLine();
                    //擪Ɋg^C^Os͓ǂݔ΂
                    Regex r = new Regex(@"^\[(?<min>[0-9][0-9]):(?<sec>[0-9][0-9]):(?<msec>[0-9][0-9])\]");
                    Match m = r.Match(s);
                    if (!m.Success) continue;
                    //g^C^O
                    s = Regex.Replace(s, @"\[[0-9][0-9]:[0-9][0-9]:[0-9][0-9]\]", "");
                    int time = (int)Validation.Val(m.Groups["min"].Value) * 60 * 1000
                        + (int)Validation.Val(m.Groups["sec"].Value) * 1000
                        + (int)Validation.Val(m.Groups["msec"].Value) * 10;
                    dataGridView1.Rows.Add(time, s, KanaConversion.GetReverseConversion(s, textBox1.Handle)[0]);
                }
            }
            else if (radioButton5.Checked)
            {
                XmlReaderSettings xrs = new XmlReaderSettings();
                xrs.CloseInput = true;
                xrs.ConformanceLevel = ConformanceLevel.Fragment;
                xrs.IgnoreWhitespace = true;
                while (st.Position < st.Length)
                    if (st.ReadByte() == (int)'\n')
                        break;
                XmlReader xr = XmlReader.Create(st, xrs);

                try
                {
                    //xr.Read();
                    //if (xr.NodeType != XmlNodeType.XmlDeclaration) throw new InvalidDataException();
                    xr.Read();
                    textBox1.Text = CheckXmlElement(xr, "musicname");
                    xr.Read();
                    int saimon = int.Parse(CheckXmlElement(xr, "saidaimondaisuu"));
                    dataGridView1.Rows.Clear();
                    for (int i = 0; i < saimon + 1; i++)
                    {
                        xr.Read();
                        dataGridView1.Rows.Add(null, CheckXmlElement(xr, "nihongoword"), "");
                    }
                    for (int i = 0; i < saimon + 1; i++)
                    {
                        xr.Read();
                        dataGridView1.Rows[i].Cells[2].Value = CheckXmlElement(xr, "word");
                    }
                    dataGridView1.Rows.RemoveAt(0);
                    int time = 0;
                    for (int i = 0; i < saimon; i++)
                    {
                        xr.Read();
                        time += int.Parse(CheckXmlElement(xr, "interval"));
                        dataGridView1.Rows[i].Cells[0].Value = time.ToString();
                    }
                }
                catch (InvalidDataException ex)
                {
                    xr.Close();
                    MessageBox.Show("XMĽ`܂B", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
            }
            st.Close();
        }

        private void dataGridView1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Enter && dataGridView1.CurrentCell.ColumnIndex == 0)
            {
                dataGridView1.Rows[dataGridView1.CurrentRow.Index - 1].Cells[0].Value = Math.Round(axWindowsMediaPlayer1.Ctlcontrols.currentPosition * 1000);
            }
        }

        private void dataGridView1_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            DataGridView dgv = (DataGridView)sender;
            if (e.RowIndex >= 0 && dgv.Rows[e.RowIndex].Cells[0].Value != null)
                axWindowsMediaPlayer1.Ctlcontrols.currentPosition = Validation.Val(dgv.Rows[e.RowIndex].Cells[0].Value.ToString()) / 1000d;
        }

        private void contextMenuStrip1_Opening(object sender, CancelEventArgs e)
        {
            if (dataGridView1.SelectedRows.Count == 0)
            {
                e.Cancel = true;
                return;
            }
           if (dataGridView1.SelectedRows.Count == 1)
               contextMenuStrip1.Items[2].Enabled = true;
           else
               contextMenuStrip1.Items[2].Enabled = false;
           if (dataGridView1.SelectedRows[dataGridView1.SelectedRows.Count - 1].IsNewRow)
           {
               contextMenuStrip1.Items[1].Enabled = false;
               ToolStripMenuItem.Enabled = false;
           }
           else
           {
               contextMenuStrip1.Items[1].Enabled = true;
               ToolStripMenuItem.Enabled = true;
           }
        }

        private void ӂ肪Ȏ擾ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            foreach (DataGridViewRow r in dataGridView1.SelectedRows)
                if (r.Cells[1].Value != null)
                    r.Cells[2].Value = KanaConversion.GetReverseConversion(r.Cells[1].Value.ToString(), this.Handle)[0];
        }

        private void s̍폜ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            foreach (DataGridViewRow r in dataGridView1.SelectedRows)
                if(!r.IsNewRow)
                    dataGridView1.Rows.Remove(r);
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dataGridView1.Rows.Insert(dataGridView1.SelectedRows[0].Index, 1);
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dataGridView1.Rows.Insert(dataGridView1.SelectedRows[0].Index + 1, 1);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (dataGridView1.Rows[0].Cells[1].Value == null) return;
            if(dataGridView1.Rows[0].Cells[1].Value.ToString() == "@")
            {
                if(MessageBox.Show("擪s@͎ő}̂ŕKv܂B폜܂H", this.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                    dataGridView1.Rows.RemoveAt(0);
            }
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Filter = "XMLt@C(*.xml)|*.xml|ׂẴt@C(*.*)|*.*";
            if (sfd.ShowDialog() == DialogResult.OK)
            {
                XmlWriterSettings xws = new XmlWriterSettings();
                xws.Encoding = Encoding.UTF8;
                xws.Indent = true;
                xws.IndentChars = ("\t");
                xws.CloseOutput = true;
                xws.ConformanceLevel = ConformanceLevel.Fragment;
                XmlWriter xw = XmlWriter.Create(sfd.OpenFile(), xws);

                //xw.WriteStartDocument(true);
                xw.WriteRaw(@"<?xml version=g1.0h encoding=gUTF-8h standalone=gyesh?>");
                xw.WriteRaw(Environment.NewLine);
                xw.WriteElementString("musicname", textBox1.Text);
                xw.WriteRaw(Environment.NewLine);
                xw.WriteElementString("saidaimondaisuu", (dataGridView1.Rows.Count - 1).ToString());
                xw.WriteRaw(Environment.NewLine);
                xw.WriteElementString("nihongoword", "@");
                xw.WriteRaw(Environment.NewLine);
                foreach (DataGridViewRow r in dataGridView1.Rows)
                {
                    if (!r.IsNewRow)
                    {
                        xw.WriteElementString("nihongoword", r.Cells[1].Value.ToString());
                        xw.WriteRaw(Environment.NewLine);

                    }
                }
                xw.WriteElementString("word", "@");
                xw.WriteRaw(Environment.NewLine);
                foreach (DataGridViewRow r in dataGridView1.Rows)
                {
                    if (!r.IsNewRow)
                    {
                        xw.WriteElementString("word", r.Cells[2].Value.ToString());
                        xw.WriteRaw(Environment.NewLine);
                    }
                }
                int time = 0;
                foreach (DataGridViewRow r in dataGridView1.Rows)
                {
                    if (!r.IsNewRow)
                    {
                        xw.WriteElementString("interval", (Validation.Val(r.Cells[0].Value) - time).ToString());
                        xw.WriteRaw(Environment.NewLine);
                        time = (int)Validation.Val(r.Cells[0].Value);
                    }
                }
                xw.Close();
                MessageBox.Show("܂", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void dataGridView1_CellValueChanged(object sender, DataGridViewCellEventArgs e)
        {
            if (e.ColumnIndex == 2 && e.RowIndex >= 0)
            {
                DataGridView dgv = (DataGridView)sender;
                // Xy[Xu
                dgv[e.ColumnIndex, e.RowIndex].Value = dgv[e.ColumnIndex, e.RowIndex].Value.ToString();
            }
        }

        /// <summary>
        /// XML̗vfAe擾܂B
        /// </summary>
        /// <param name="xr">ǂݍݑΏۂXmlReader</param>
        /// <param name="elmName">vf</param>
        /// <returns>vf̓e</returns>
        /// <exception cref="InvalidDataException"></exception>
        private string CheckXmlElement(XmlReader xr, string elmName)
        {
            if (xr.NodeType != XmlNodeType.Element) throw new InvalidDataException();
            if (xr.Name != elmName) throw new InvalidDataException();
            xr.Read();
            if (xr.NodeType != XmlNodeType.Text) throw new InvalidDataException();
            string txt = xr.Value;
            xr.Read();
            if (xr.NodeType != XmlNodeType.EndElement) throw new InvalidDataException();
            if (xr.Name != elmName) throw new InvalidDataException();
            return txt;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (dataGridView1.SelectedRows.Count == 1)
            {
                if (dataGridView1.CurrentRow.IsNewRow)
                {
                    dataGridView1.Rows.Add(null, "", "");
                    dataGridView1.CurrentCell = dataGridView1.Rows[dataGridView1.CurrentRow.Index - 1].Cells[0];
                }
                dataGridView1.CurrentRow.Cells[0].Value = Math.Round(axWindowsMediaPlayer1.Ctlcontrols.currentPosition * 1000);
                dataGridView1.CurrentCell = dataGridView1.Rows[dataGridView1.CurrentRow.Index + 1].Cells[0];
            }
            else
            {
                MessageBox.Show("s̑Iѕ܂B", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void axWindowsMediaPlayer1_DoubleClickEvent(object sender, AxWMPLib._WMPOCXEvents_DoubleClickEvent e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "MP3t@C(*.mp3)|*.mp3|ׂẴt@C(*.*)|*.*";
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                AxWMPLib.AxWindowsMediaPlayer wmp = (AxWMPLib.AxWindowsMediaPlayer)sender;
                wmp.URL = ofd.FileName;
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (frm2.Visible)
                frm2.Activate();
            else
                frm2.Show();
        }
    }

    /// <summary>
    /// ȕϊ@\񋟂NX
    /// </summary>
    public static class KanaConversion
    {
        private const int GCL_REVERSECONVERSION = 0x0002;

        [DllImport("Imm32.dll")]
        private static extern IntPtr ImmGetContext(IntPtr hWnd);

        [DllImport("User32.dll")]
        private static extern IntPtr GetKeyboardLayout(int idThread);

        [DllImport("Imm32.dll")]
        private static extern int ImmGetConversionList(
            IntPtr hKL,
            IntPtr hIMC,
            string lpSrc,
            IntPtr lpDst,
            int dwBufLen,
            int uFlag
            );

        [DllImport("Imm32.dll")]
        private static extern bool ImmReleaseContext(IntPtr hWnd, IntPtr hIMC);

        [StructLayout(LayoutKind.Sequential)]
        private class CANDIDATELIST
        {
            public int dwSize;
            public int dwStyle;
            public int dwCount;
            public int dwSelection;
            public int dwPageStart;
            public int dwPageSize;
            public int dwOffset;
        }
        /// <summary>
        /// tϊ܂Biӂ肪Ȏ擾j
        /// </summary>
        /// <param name="AText">ϊeLXg</param>
        /// <param name="AHwnd">EBhEnh(Form.Handle)</param>
        /// <returns>ϊ̌stringz</returns>
        public static string[] GetReverseConversion(string AText, IntPtr AHwnd)
        {
            string[] strList = null;
            IntPtr hIMC = ImmGetContext(AHwnd);
            IntPtr hKL = GetKeyboardLayout(0);
            if ((hIMC != IntPtr.Zero) && (hKL != IntPtr.Zero))
            {
                CANDIDATELIST list = new CANDIDATELIST();
                int dwSize = ImmGetConversionList(hKL, hIMC, AText, IntPtr.Zero, 0, GCL_REVERSECONVERSION);
                if (dwSize > 0)
                {
                    IntPtr BufList = Marshal.AllocHGlobal(dwSize);
                    ImmGetConversionList(hKL, hIMC, AText, BufList, dwSize, GCL_REVERSECONVERSION);
                    Marshal.PtrToStructure(BufList, list);
                    byte[] buf = new byte[dwSize];
                    Marshal.Copy(BufList, buf, 0, dwSize);
                    Marshal.FreeHGlobal(BufList);
                    int os = list.dwOffset;
                    string str = System.Text.Encoding.Default.GetString(buf, os, buf.Length - os);
                    str = System.Text.RegularExpressions.Regex.Replace(str, @"\0+$", "");
                    char[] par = "\0".ToCharArray();
                    strList = str.Split(par);
                    ImmReleaseContext(AHwnd, hIMC);
                }
            }
            return strList;
        }
    }

    /// -----------------------------------------------------------------------------
    /// <summary>
    ///     ؁EG[`FbNT|[gÓINXłB
    /// </summary>
    /// -----------------------------------------------------------------------------
    public sealed class Validation
    {

        #region@Val \bh (+2)

        /// -----------------------------------------------------------------------------
        /// <summary>
        ///     w肵Ɋ܂܂鐔lϊĕԂ܂B</summary>
        /// <param name="stTarget">
        ///     Cӂ̗LȕB</param>
        /// <returns>
        ///     w肵Ɋ܂܂鐔lB</returns>
        /// -----------------------------------------------------------------------------
        public static double Val(string stTarget)
        {
            // Null l̏ꍇ 0 Ԃ
            if (stTarget == null)
            {
                return 0D;
            }

            int iCurrent = 0;
            int iLength = stTarget.Length;

            // ]ΏۊO̕XLbv
            for (iCurrent = 0; iCurrent < iLength; iCurrent++)
            {
                char chOne = stTarget[iCurrent];

                if ((chOne != ' ') && (chOne != '@') && (chOne != '\t') && (chOne != '\n') && (chOne != '\r'))
                {
                    break;
                }
            }

            // I[܂łɗLȕȂꍇ 0 Ԃ
            if (iCurrent >= iLength)
            {
                return 0D;
            }

            bool bMinus = false;

            // 擪ɂ镄𔻒肷
            switch (stTarget[iCurrent])
            {
                case '-':
                    bMinus = true;
                    iCurrent++;
                    break;
                case '+':
                    iCurrent++;
                    break;
            }

            int iValidLength = 0;
            int iPriod = 0;

            double dReturn = 0D;

            bool bDecimal = false;
            bool bShisuMark = false;

            // 1 Lȕǂ肷
            while (iCurrent < iLength)
            {
                char chCurrent = stTarget[iCurrent];

                if ((chCurrent == ' ') || (chCurrent == '@') || (chCurrent == '\t') || (chCurrent == '\n') || (chCurrent == '\r'))
                {
                    iCurrent++;
                }
                else if (chCurrent == '0')
                {
                    iCurrent++;

                    if ((iValidLength != 0) || bDecimal)
                    {
                        iValidLength++;
                        dReturn = (dReturn * 10) + double.Parse(chCurrent.ToString());
                    }
                }
                else if ((chCurrent >= '1') && (chCurrent <= '9'))
                {
                    iCurrent++;
                    iValidLength++;
                    dReturn = (dReturn * 10) + double.Parse(chCurrent.ToString());
                }
                else if (chCurrent == '.')
                {
                    iCurrent++;

                    if (bDecimal)
                    {
                        break;
                    }

                    bDecimal = true;
                    iPriod = iValidLength;
                }
                else if ((chCurrent == 'e') || (chCurrent == 'E') || (chCurrent == 'd') || (chCurrent == 'D'))
                {
                    bShisuMark = true;
                    iCurrent++;
                    break;
                }
                else
                {
                    break;
                }
            }

            int iDecimal = 0;

            // _肳ꂽꍇ
            if (bDecimal)
            {
                iDecimal = iValidLength - iPriod;
            }

            // w肳ꂽꍇ
            if (bShisuMark)
            {
                bool bShisuValid = false;
                bool bShisuMinus = false;
                double dCoef = 0D;

                // w؂
                while (iCurrent < iLength)
                {
                    char chCurrent = stTarget[iCurrent];

                    if ((chCurrent == ' ') || (chCurrent == '@') || (chCurrent == '\t') || (chCurrent == '\n') || (chCurrent == '\r'))
                    {
                        iCurrent++;
                    }
                    else if ((chCurrent >= '0') && (chCurrent <= '9'))
                    {
                        dCoef = (dCoef * 10) + double.Parse(chCurrent.ToString());
                        iCurrent++;
                    }
                    else if (chCurrent == '+')
                    {
                        if (bShisuValid)
                        {
                            break;
                        }

                        bShisuValid = true;
                        iCurrent++;
                    }
                    else if ((chCurrent != '-') || bShisuValid)
                    {
                        break;
                    }
                    else
                    {
                        bShisuValid = true;
                        bShisuMinus = true;
                        iCurrent++;
                    }
                }

                // w̕ɉėݏ悷
                if (bShisuMinus)
                {
                    dCoef += iDecimal;
                    dReturn *= System.Math.Pow(10, -dCoef);
                }
                else
                {
                    dCoef -= iDecimal;
                    dReturn *= System.Math.Pow(10, dCoef);
                }
            }
            else if (bDecimal && (iDecimal != 0))
            {
                dReturn /= System.Math.Pow(10, iDecimal);
            }

            // ̏ꍇ 0 Ԃ
            if (double.IsInfinity(dReturn))
            {
                return 0D;
            }

            // }CiX̏ꍇ̓}CiXŕԂ
            if (bMinus)
            {
                return -dReturn;
            }

            return dReturn;
        }

        /// -----------------------------------------------------------------------------
        /// <summary>
        ///     w肵Ɋ܂܂鐔lϊĕԂ܂B</summary>
        /// <param name="chTarget">
        ///     Cӂ̗LȕB</param>
        /// <returns>
        ///     w肵Ɋ܂܂鐔lB</returns>
        /// -----------------------------------------------------------------------------
        public static int Val(char chTarget)
        {
            return (int)Val(chTarget.ToString());
        }

        /// -----------------------------------------------------------------------------
        /// <summary>
        ///     w肵IuWFNgɊ܂܂鐔lϊĕԂ܂B</summary>
        /// <param name="oTarget">
        ///     Cӂ̗LȃIuWFNgB</param>
        /// <returns>
        ///     w肵IuWFNgɊ܂܂鐔lB</returns>
        /// -----------------------------------------------------------------------------
        public static double Val(object oTarget)
        {
            if (oTarget != null)
            {
                return Val(oTarget.ToString());
            }

            return 0D;
        }

        #endregion

    }
}